#include "log/Log.h"
#include "io/Serial.h"
#include "std/stdio.h"

void KernelLog::log(const char* function, const char* message, LogLevel level)
{
    Serial::reset_color();
    Serial::print(function);
    Serial::print(": ");
    switch (level)
    {
    case LogLevel::WARN: Serial::set_color(Color::Yellow); break;
    case LogLevel::ERROR: Serial::set_color(Color::Red); break;
    default: break;
    }
    printf("%s", message);
    Serial::reset_color();
}

void KernelLog::logln(const char* function, const char* message, LogLevel level)
{
    log(function, message, level);
    Serial::print("\n");
}